1# Test framework for git. See t/README for usage.
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
17
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
70# For repeatability, reset the environment to known value.
71LANG=C
72LC_ALL=C
73PAGER=cat
74TZ=UTC
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
77EDITOR=:
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
98')
99unset XDG_CONFIG_HOME
100unset GITPERLLIB
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
105GIT_MERGE_VERBOSITY=5
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110export EDITOR
111
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
142
143: ${ASAN_OPTIONS=detect_leaks=0}
144export ASAN_OPTIONS
145
146# Protect ourselves from common misconfiguration to export
147# CDPATH into the environment
148unset CDPATH
149
150unset GREP_OPTIONS
151unset UNZIP
152
153case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1541|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
159 ;;
160esac
161
162# Convenience
163#
164# A regexp to match 5 and 40 hexdigits
165_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
167
168# Zero SHA-1
169_z40=0000000000000000000000000000000000000000
170
171# Line feed
172LF='
173'
174
175# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176# when case-folding filenames
177u200c=$(printf '\342\200\214')
178
179export _x05 _x40 _z40 LF u200c
180
181# Each test should start with something like this, after copyright notices:
182#
183# test_description='Description of this test...
184# This test checks if command xyzzy does the right thing...
185# '
186# . ./test-lib.sh
187
188unset color
189while test "$#" -ne 0
190do
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
198 -r)
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
202 }
203 run_list=$1; shift ;;
204 --run=*)
205 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
206 -h|--h|--he|--hel|--help)
207 help=t; shift ;;
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
210 --verbose-only=*)
211 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
213 -q|--q|--qu|--qui|--quie|--quiet)
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
217 --with-dashes)
218 with_dashes=t; shift ;;
219 --no-color)
220 color=; shift ;;
221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
225 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
227 --valgrind-only=*)
228 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
229 shift ;;
230 --tee)
231 shift ;; # was handled already
232 --root=*)
233 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
235 --chain-lint)
236 GIT_TEST_CHAIN_LINT=1
237 shift ;;
238 --no-chain-lint)
239 GIT_TEST_CHAIN_LINT=0
240 shift ;;
241 -x)
242 trace=t
243 verbose=t
244 shift ;;
245 *)
246 echo "error: unknown test option '$1'" >&2; exit 1 ;;
247 esac
248done
249
250if test -n "$valgrind_only"
251then
252 test -z "$valgrind" && valgrind=memcheck
253 test -z "$verbose" && verbose_only="$valgrind_only"
254elif test -n "$valgrind"
255then
256 verbose=t
257fi
258
259error () {
260 say_color error "error: $*"
261 GIT_EXIT_OK=t
262 exit 1
263}
264
265say () {
266 say_color info "$*"
267}
268
269test "${test_description}" != "" ||
270error "Test script did not set test_description."
271
272if test "$help" = "t"
273then
274 printf '%s\n' "$test_description"
275 exit 0
276fi
277
278exec 5>&1
279exec 6<&0
280if test "$verbose" = "t"
281then
282 exec 4>&2 3>&1
283else
284 exec 4>/dev/null 3>/dev/null
285fi
286
287test_failure=0
288test_count=0
289test_fixed=0
290test_broken=0
291test_success=0
292
293test_external_has_tap=0
294
295die () {
296 code=$?
297 if test -n "$GIT_EXIT_OK"
298 then
299 exit $code
300 else
301 echo >&5 "FATAL: Unexpected exit with code $code"
302 exit 1
303 fi
304}
305
306GIT_EXIT_OK=
307trap 'die' EXIT
308
309# The user-facing functions are loaded from a separate file so that
310# test_perf subshells can have them too
311. "$TEST_DIRECTORY/test-lib-functions.sh"
312
313# You are not expected to call test_ok_ and test_failure_ directly, use
314# the test_expect_* functions instead.
315
316test_ok_ () {
317 test_success=$(($test_success + 1))
318 say_color "" "ok $test_count - $@"
319}
320
321test_failure_ () {
322 test_failure=$(($test_failure + 1))
323 say_color error "not ok $test_count - $1"
324 shift
325 printf '%s\n' "$*" | sed -e 's/^/# /'
326 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
327}
328
329test_known_broken_ok_ () {
330 test_fixed=$(($test_fixed+1))
331 say_color error "ok $test_count - $@ # TODO known breakage vanished"
332}
333
334test_known_broken_failure_ () {
335 test_broken=$(($test_broken+1))
336 say_color warn "not ok $test_count - $@ # TODO known breakage"
337}
338
339test_debug () {
340 test "$debug" = "" || eval "$1"
341}
342
343match_pattern_list () {
344 arg="$1"
345 shift
346 test -z "$*" && return 1
347 for pattern_
348 do
349 case "$arg" in
350 $pattern_)
351 return 0
352 esac
353 done
354 return 1
355}
356
357match_test_selector_list () {
358 title="$1"
359 shift
360 arg="$1"
361 shift
362 test -z "$1" && return 0
363
364 # Both commas and whitespace are accepted as separators.
365 OLDIFS=$IFS
366 IFS=' ,'
367 set -- $1
368 IFS=$OLDIFS
369
370 # If the first selector is negative we include by default.
371 include=
372 case "$1" in
373 !*) include=t ;;
374 esac
375
376 for selector
377 do
378 orig_selector=$selector
379
380 positive=t
381 case "$selector" in
382 !*)
383 positive=
384 selector=${selector##?}
385 ;;
386 esac
387
388 test -z "$selector" && continue
389
390 case "$selector" in
391 *-*)
392 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
393 then
394 echo "error: $title: invalid non-numeric in range" \
395 "start: '$orig_selector'" >&2
396 exit 1
397 fi
398 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
399 then
400 echo "error: $title: invalid non-numeric in range" \
401 "end: '$orig_selector'" >&2
402 exit 1
403 fi
404 ;;
405 *)
406 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
407 then
408 echo "error: $title: invalid non-numeric in test" \
409 "selector: '$orig_selector'" >&2
410 exit 1
411 fi
412 esac
413
414 # Short cut for "obvious" cases
415 test -z "$include" && test -z "$positive" && continue
416 test -n "$include" && test -n "$positive" && continue
417
418 case "$selector" in
419 -*)
420 if test $arg -le ${selector#-}
421 then
422 include=$positive
423 fi
424 ;;
425 *-)
426 if test $arg -ge ${selector%-}
427 then
428 include=$positive
429 fi
430 ;;
431 *-*)
432 if test ${selector%%-*} -le $arg \
433 && test $arg -le ${selector#*-}
434 then
435 include=$positive
436 fi
437 ;;
438 *)
439 if test $arg -eq $selector
440 then
441 include=$positive
442 fi
443 ;;
444 esac
445 done
446
447 test -n "$include"
448}
449
450maybe_teardown_verbose () {
451 test -z "$verbose_only" && return
452 exec 4>/dev/null 3>/dev/null
453 verbose=
454}
455
456last_verbose=t
457maybe_setup_verbose () {
458 test -z "$verbose_only" && return
459 if match_pattern_list $test_count $verbose_only
460 then
461 exec 4>&2 3>&1
462 # Emit a delimiting blank line when going from
463 # non-verbose to verbose. Within verbose mode the
464 # delimiter is printed by test_expect_*. The choice
465 # of the initial $last_verbose is such that before
466 # test 1, we do not print it.
467 test -z "$last_verbose" && echo >&3 ""
468 verbose=t
469 else
470 exec 4>/dev/null 3>/dev/null
471 verbose=
472 fi
473 last_verbose=$verbose
474}
475
476maybe_teardown_valgrind () {
477 test -z "$GIT_VALGRIND" && return
478 GIT_VALGRIND_ENABLED=
479}
480
481maybe_setup_valgrind () {
482 test -z "$GIT_VALGRIND" && return
483 if test -z "$valgrind_only"
484 then
485 GIT_VALGRIND_ENABLED=t
486 return
487 fi
488 GIT_VALGRIND_ENABLED=
489 if match_pattern_list $test_count $valgrind_only
490 then
491 GIT_VALGRIND_ENABLED=t
492 fi
493}
494
495want_trace () {
496 test "$trace" = t && test "$verbose" = t
497}
498
499# This is a separate function because some tests use
500# "return" to end a test_expect_success block early
501# (and we want to make sure we run any cleanup like
502# "set +x").
503test_eval_inner_ () {
504 # Do not add anything extra (including LF) after '$*'
505 eval "
506 want_trace && set -x
507 $*"
508}
509
510test_eval_ () {
511 # We run this block with stderr redirected to avoid extra cruft
512 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
513 # the shell from printing the "set +x" to turn it off (nor the saving
514 # of $? before that). But we can make sure that the output goes to
515 # /dev/null.
516 #
517 # The test itself is run with stderr put back to &4 (so either to
518 # /dev/null, or to the original stderr if --verbose was used).
519 {
520 test_eval_inner_ "$@" </dev/null >&3 2>&4
521 test_eval_ret_=$?
522 if want_trace
523 then
524 set +x
525 if test "$test_eval_ret_" != 0
526 then
527 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
528 fi
529 fi
530 } 2>/dev/null
531 return $test_eval_ret_
532}
533
534test_run_ () {
535 test_cleanup=:
536 expecting_failure=$2
537
538 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
539 # turn off tracing for this test-eval, as it simply creates
540 # confusing noise in the "-x" output
541 trace_tmp=$trace
542 trace=
543 # 117 is magic because it is unlikely to match the exit
544 # code of other programs
545 test_eval_ "(exit 117) && $1"
546 if test "$?" != 117; then
547 error "bug in the test script: broken &&-chain: $1"
548 fi
549 trace=$trace_tmp
550 fi
551
552 setup_malloc_check
553 test_eval_ "$1"
554 eval_ret=$?
555 teardown_malloc_check
556
557 if test -z "$immediate" || test $eval_ret = 0 ||
558 test -n "$expecting_failure" && test "$test_cleanup" != ":"
559 then
560 setup_malloc_check
561 test_eval_ "$test_cleanup"
562 teardown_malloc_check
563 fi
564 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
565 then
566 echo ""
567 fi
568 return "$eval_ret"
569}
570
571test_start_ () {
572 test_count=$(($test_count+1))
573 maybe_setup_verbose
574 maybe_setup_valgrind
575}
576
577test_finish_ () {
578 echo >&3 ""
579 maybe_teardown_valgrind
580 maybe_teardown_verbose
581}
582
583test_skip () {
584 to_skip=
585 skipped_reason=
586 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
587 then
588 to_skip=t
589 skipped_reason="GIT_SKIP_TESTS"
590 fi
591 if test -z "$to_skip" && test -n "$test_prereq" &&
592 ! test_have_prereq "$test_prereq"
593 then
594 to_skip=t
595
596 of_prereq=
597 if test "$missing_prereq" != "$test_prereq"
598 then
599 of_prereq=" of $test_prereq"
600 fi
601 skipped_reason="missing $missing_prereq${of_prereq}"
602 fi
603 if test -z "$to_skip" && test -n "$run_list" &&
604 ! match_test_selector_list '--run' $test_count "$run_list"
605 then
606 to_skip=t
607 skipped_reason="--run"
608 fi
609
610 case "$to_skip" in
611 t)
612 say_color skip >&3 "skipping test: $@"
613 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
614 : true
615 ;;
616 *)
617 false
618 ;;
619 esac
620}
621
622# stub; perf-lib overrides it
623test_at_end_hook_ () {
624 :
625}
626
627test_done () {
628 GIT_EXIT_OK=t
629
630 if test -z "$HARNESS_ACTIVE"
631 then
632 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
633 mkdir -p "$test_results_dir"
634 base=${0##*/}
635 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
636
637 cat >>"$test_results_path" <<-EOF
638 total $test_count
639 success $test_success
640 fixed $test_fixed
641 broken $test_broken
642 failed $test_failure
643
644 EOF
645 fi
646
647 if test "$test_fixed" != 0
648 then
649 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
650 fi
651 if test "$test_broken" != 0
652 then
653 say_color warn "# still have $test_broken known breakage(s)"
654 fi
655 if test "$test_broken" != 0 || test "$test_fixed" != 0
656 then
657 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
658 msg="remaining $test_remaining test(s)"
659 else
660 test_remaining=$test_count
661 msg="$test_count test(s)"
662 fi
663 case "$test_failure" in
664 0)
665 # Maybe print SKIP message
666 if test -n "$skip_all" && test $test_count -gt 0
667 then
668 error "Can't use skip_all after running some tests"
669 fi
670 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
671
672 if test $test_external_has_tap -eq 0
673 then
674 if test $test_remaining -gt 0
675 then
676 say_color pass "# passed all $msg"
677 fi
678 say "1..$test_count$skip_all"
679 fi
680
681 test -d "$remove_trash" &&
682 cd "$(dirname "$remove_trash")" &&
683 rm -rf "$(basename "$remove_trash")"
684
685 test_at_end_hook_
686
687 exit 0 ;;
688
689 *)
690 if test $test_external_has_tap -eq 0
691 then
692 say_color error "# failed $test_failure among $msg"
693 say "1..$test_count"
694 fi
695
696 exit 1 ;;
697
698 esac
699}
700
701if test -n "$valgrind"
702then
703 make_symlink () {
704 test -h "$2" &&
705 test "$1" = "$(readlink "$2")" || {
706 # be super paranoid
707 if mkdir "$2".lock
708 then
709 rm -f "$2" &&
710 ln -s "$1" "$2" &&
711 rm -r "$2".lock
712 else
713 while test -d "$2".lock
714 do
715 say "Waiting for lock on $2."
716 sleep 1
717 done
718 fi
719 }
720 }
721
722 make_valgrind_symlink () {
723 # handle only executables, unless they are shell libraries that
724 # need to be in the exec-path.
725 test -x "$1" ||
726 test "# " = "$(head -c 2 <"$1")" ||
727 return;
728
729 base=$(basename "$1")
730 symlink_target=$GIT_BUILD_DIR/$base
731 # do not override scripts
732 if test -x "$symlink_target" &&
733 test ! -d "$symlink_target" &&
734 test "#!" != "$(head -c 2 < "$symlink_target")"
735 then
736 symlink_target=../valgrind.sh
737 fi
738 case "$base" in
739 *.sh|*.perl)
740 symlink_target=../unprocessed-script
741 esac
742 # create the link, or replace it if it is out of date
743 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
744 }
745
746 # override all git executables in TEST_DIRECTORY/..
747 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
748 mkdir -p "$GIT_VALGRIND"/bin
749 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
750 do
751 make_valgrind_symlink $file
752 done
753 # special-case the mergetools loadables
754 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
755 OLDIFS=$IFS
756 IFS=:
757 for path in $PATH
758 do
759 ls "$path"/git-* 2> /dev/null |
760 while read file
761 do
762 make_valgrind_symlink "$file"
763 done
764 done
765 IFS=$OLDIFS
766 PATH=$GIT_VALGRIND/bin:$PATH
767 GIT_EXEC_PATH=$GIT_VALGRIND/bin
768 export GIT_VALGRIND
769 GIT_VALGRIND_MODE="$valgrind"
770 export GIT_VALGRIND_MODE
771 GIT_VALGRIND_ENABLED=t
772 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
773 export GIT_VALGRIND_ENABLED
774elif test -n "$GIT_TEST_INSTALLED"
775then
776 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
777 error "Cannot run git from $GIT_TEST_INSTALLED."
778 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
779 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
780else # normal case, use ../bin-wrappers only unless $with_dashes:
781 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
782 if ! test -x "$git_bin_dir/git"
783 then
784 if test -z "$with_dashes"
785 then
786 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
787 fi
788 with_dashes=t
789 fi
790 PATH="$git_bin_dir:$PATH"
791 GIT_EXEC_PATH=$GIT_BUILD_DIR
792 if test -n "$with_dashes"
793 then
794 PATH="$GIT_BUILD_DIR:$PATH"
795 fi
796fi
797GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
798GIT_CONFIG_NOSYSTEM=1
799GIT_ATTR_NOSYSTEM=1
800export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
801
802if test -z "$GIT_TEST_CMP"
803then
804 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
805 then
806 GIT_TEST_CMP="$DIFF -c"
807 else
808 GIT_TEST_CMP="$DIFF -u"
809 fi
810fi
811
812GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
813export GITPERLLIB
814test -d "$GIT_BUILD_DIR"/templates/blt || {
815 error "You haven't built things yet, have you?"
816}
817
818if ! test -x "$GIT_BUILD_DIR"/test-chmtime
819then
820 echo >&2 'You need to build test-chmtime:'
821 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
822 exit 1
823fi
824
825# Test repository
826TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
827test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
828case "$TRASH_DIRECTORY" in
829/*) ;; # absolute path is good
830 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
831esac
832test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
833rm -fr "$TRASH_DIRECTORY" || {
834 GIT_EXIT_OK=t
835 echo >&5 "FATAL: Cannot prepare test area"
836 exit 1
837}
838
839HOME="$TRASH_DIRECTORY"
840GNUPGHOME="$HOME/gnupg-home-not-used"
841export HOME GNUPGHOME
842
843# run the tput tests *after* changing HOME (in case ncurses needs
844# ~/.terminfo for $TERM)
845test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
846 TERM=$ORIGINAL_TERM &&
847 export TERM &&
848 test -t 1 &&
849 tput bold >/dev/null 2>&1 &&
850 tput setaf 1 >/dev/null 2>&1 &&
851 tput sgr0 >/dev/null 2>&1
852 ) &&
853 color=t
854
855if test -n "$color"
856then
857 say_color () {
858 (
859 TERM=$ORIGINAL_TERM
860 export TERM
861 case "$1" in
862 error)
863 tput bold; tput setaf 1;; # bold red
864 skip)
865 tput setaf 4;; # blue
866 warn)
867 tput setaf 3;; # brown/yellow
868 pass)
869 tput setaf 2;; # green
870 info)
871 tput setaf 6;; # cyan
872 *)
873 test -n "$quiet" && return;;
874 esac
875 shift
876 printf "%s" "$*"
877 tput sgr0
878 echo
879 )
880 }
881else
882 say_color() {
883 test -z "$1" && test -n "$quiet" && return
884 shift
885 printf "%s\n" "$*"
886 }
887fi
888
889if test -z "$TEST_NO_CREATE_REPO"
890then
891 test_create_repo "$TRASH_DIRECTORY"
892else
893 mkdir -p "$TRASH_DIRECTORY"
894fi
895# Use -P to resolve symlinks in our working directory so that the cwd
896# in subprocesses like git equals our $PWD (for pathname comparisons).
897cd -P "$TRASH_DIRECTORY" || exit 1
898
899this_test=${0##*/}
900this_test=${this_test%%-*}
901if match_pattern_list "$this_test" $GIT_SKIP_TESTS
902then
903 say_color info >&3 "skipping test $this_test altogether"
904 skip_all="skip all tests in $this_test"
905 test_done
906fi
907
908# Provide an implementation of the 'yes' utility
909yes () {
910 if test $# = 0
911 then
912 y=y
913 else
914 y="$*"
915 fi
916
917 while echo "$y"
918 do
919 :
920 done
921}
922
923# Fix some commands on Windows
924case $(uname -s) in
925*MINGW*)
926 # Windows has its own (incompatible) sort and find
927 sort () {
928 /usr/bin/sort "$@"
929 }
930 find () {
931 /usr/bin/find "$@"
932 }
933 sum () {
934 md5sum "$@"
935 }
936 # git sees Windows-style pwd
937 pwd () {
938 builtin pwd -W
939 }
940 # no POSIX permissions
941 # backslashes in pathspec are converted to '/'
942 # exec does not inherit the PID
943 test_set_prereq MINGW
944 test_set_prereq NATIVE_CRLF
945 test_set_prereq SED_STRIPS_CR
946 test_set_prereq GREP_STRIPS_CR
947 GIT_TEST_CMP=mingw_test_cmp
948 ;;
949*CYGWIN*)
950 test_set_prereq POSIXPERM
951 test_set_prereq EXECKEEPSPID
952 test_set_prereq CYGWIN
953 test_set_prereq SED_STRIPS_CR
954 test_set_prereq GREP_STRIPS_CR
955 ;;
956*)
957 test_set_prereq POSIXPERM
958 test_set_prereq BSLASHPSPEC
959 test_set_prereq EXECKEEPSPID
960 ;;
961esac
962
963( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
964test -z "$NO_PERL" && test_set_prereq PERL
965test -z "$NO_PYTHON" && test_set_prereq PYTHON
966test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
967test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
968
969# Can we rely on git's output in the C locale?
970if test -n "$GETTEXT_POISON"
971then
972 GIT_GETTEXT_POISON=YesPlease
973 export GIT_GETTEXT_POISON
974 test_set_prereq GETTEXT_POISON
975else
976 test_set_prereq C_LOCALE_OUTPUT
977fi
978
979# Use this instead of test_cmp to compare files that contain expected and
980# actual output from git commands that can be translated. When running
981# under GETTEXT_POISON this pretends that the command produced expected
982# results.
983test_i18ncmp () {
984 test -n "$GETTEXT_POISON" || test_cmp "$@"
985}
986
987# Use this instead of "grep expected-string actual" to see if the
988# output from a git command that can be translated either contains an
989# expected string, or does not contain an unwanted one. When running
990# under GETTEXT_POISON this pretends that the command produced expected
991# results.
992test_i18ngrep () {
993 if test -n "$GETTEXT_POISON"
994 then
995 : # pretend success
996 elif test "x!" = "x$1"
997 then
998 shift
999 ! grep "$@"
1000 else
1001 grep "$@"
1002 fi
1003}
1004
1005test_lazy_prereq PIPE '
1006 # test whether the filesystem supports FIFOs
1007 case $(uname -s) in
1008 CYGWIN*)
1009 false
1010 ;;
1011 *)
1012 rm -f testfifo && mkfifo testfifo
1013 ;;
1014 esac
1015'
1016
1017test_lazy_prereq SYMLINKS '
1018 # test whether the filesystem supports symbolic links
1019 ln -s x y && test -h y
1020'
1021
1022test_lazy_prereq FILEMODE '
1023 test "$(git config --bool core.filemode)" = true
1024'
1025
1026test_lazy_prereq CASE_INSENSITIVE_FS '
1027 echo good >CamelCase &&
1028 echo bad >camelcase &&
1029 test "$(cat CamelCase)" != good
1030'
1031
1032test_lazy_prereq UTF8_NFD_TO_NFC '
1033 # check whether FS converts nfd unicode to nfc
1034 auml=$(printf "\303\244")
1035 aumlcdiar=$(printf "\141\314\210")
1036 >"$auml" &&
1037 case "$(echo *)" in
1038 "$aumlcdiar")
1039 true ;;
1040 *)
1041 false ;;
1042 esac
1043'
1044
1045test_lazy_prereq AUTOIDENT '
1046 sane_unset GIT_AUTHOR_NAME &&
1047 sane_unset GIT_AUTHOR_EMAIL &&
1048 git var GIT_AUTHOR_IDENT
1049'
1050
1051test_lazy_prereq EXPENSIVE '
1052 test -n "$GIT_TEST_LONG"
1053'
1054
1055test_lazy_prereq USR_BIN_TIME '
1056 test -x /usr/bin/time
1057'
1058
1059test_lazy_prereq NOT_ROOT '
1060 uid=$(id -u) &&
1061 test "$uid" != 0
1062'
1063
1064# On a filesystem that lacks SANITY, a file can be deleted even if
1065# the containing directory doesn't have write permissions, or a file
1066# can be accessed even if the containing directory doesn't have read
1067# or execute permissions, causing our tests that validate that Git
1068# works sensibly in such situations.
1069test_lazy_prereq SANITY '
1070 mkdir SANETESTD.1 SANETESTD.2 &&
1071
1072 chmod +w SANETESTD.1 SANETESTD.2 &&
1073 >SANETESTD.1/x 2>SANETESTD.2/x &&
1074 chmod -w SANETESTD.1 &&
1075 chmod -rx SANETESTD.2 ||
1076 error "bug in test sript: cannot prepare SANETESTD"
1077
1078 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1079 status=$?
1080
1081 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1082 rm -rf SANETESTD.1 SANETESTD.2 ||
1083 error "bug in test sript: cannot clean SANETESTD"
1084 return $status
1085'
1086
1087GIT_UNZIP=${GIT_UNZIP:-unzip}
1088test_lazy_prereq UNZIP '
1089 "$GIT_UNZIP" -v
1090 test $? -ne 127
1091'